/**
  *  \file server/request.h
  */
#ifndef C2SERVER_SERVER_REQUEST_H
#define C2SERVER_SERVER_REQUEST_H

#include <cstddef>
#include "cpluslib/string.h"

class Request {
    enum { MAX_LENGTH = 4096 /*16384*/ };  /* FIXME: small for testing */
    std::size_t length;
    std::size_t read_ptr;
    char buffer[MAX_LENGTH];
 public:
    enum State {
        sSuccess,
        sEOF,
        sError,
        sTooLong
    };

    Request();

    char* readLine();
    State readMore(int fd);
    bool shift();
    void clear();
    std::size_t readData(void* bufout, std::size_t amount);
};

void writeStr(int fd, const char* str);
void writeStr(int fd, string_t str);

#endif
